#include <lib_cisnewbar.mqh>
#property indicator_separate_window
#property indicator_plots 2
#property indicator_buffers 2 

#property indicator_type1 DRAW_HISTOGRAM
#property indicator_color1 Lime
#property indicator_style1 STYLE_SOLID
#property indicator_label1 "Tick "

#property indicator_type2 DRAW_HISTOGRAM 
#property indicator_color2 Red
#property indicator_style2 STYLE_SOLID
#property indicator_label2 "Tick "

double   UpTick[];
double   DnTick[];
double   _Bid,_Ask,TickUp,TickDn,difference;
double   Time[];
CisNewBar current_chart;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct TickStruct                                                                                  //       
  {
   datetime          time;          //     
   double            bid;           //   Bid 
   double            ask;           //   Ask 
   double            last;          //     (Last) 
   ulong             volume;        //     Last 
   long              time_msc;      //       
   uint              flag;           //   
  };
TickStruct        g_ticks[];                                                                       //    ,                         
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {

   SetIndexBuffer(0,UpTick,INDICATOR_DATA);

   SetIndexBuffer(1,DnTick,INDICATOR_DATA);
   PlotIndexSetInteger(0,PLOT_LINE_WIDTH,2);
   PlotIndexSetInteger(1,PLOT_LINE_WIDTH,2);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,clrLime);
   PlotIndexSetInteger(1,PLOT_LINE_COLOR,clrRed);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);
   IndicatorSetInteger(INDICATOR_DIGITS,5);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   MqlTick last_tick;
   SymbolInfoTick(Symbol(),last_tick);

//--    
   TickStruct tick={0,0,0,0,0,0,0};
   tick.time=TimeCurrent();
   tick.bid=last_tick.bid;
   tick.ask=last_tick.ask;
   tick.flag=last_tick.flags;
   tick.last=last_tick.last;
   tick.time_msc=last_tick.time_msc;
   tick.volume=last_tick.volume;
   int total=ArraySize(g_ticks);
   if(ArrayResize(g_ticks,total+1,1000)<0)
     {
      Alert(":          .");
     }
   else
     {
      g_ticks[total]=tick;
      UpTick[rates_total-1]=total;
     }
   if(total>999)
     {
      SaveTempTicks();
      ArrayFree(g_ticks);
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+

void SaveTempTicks()
  {
//    
   int hTicksFile=FileOpen(Symbol()+"fullTicks.tks",FILE_BIN|FILE_READ|FILE_WRITE|FILE_SHARE_READ|FILE_SHARE_WRITE);
   if(hTicksFile<1)
      return;
   FileSeek(hTicksFile,0,SEEK_END);
//   
   int total=ArraySize(g_ticks),i=0;
   while(i<total)
     {
      if(FileWriteStruct(hTicksFile,g_ticks[i])==0)
        {
         Print("     ...");
         return;
        }

      i++;
     }

   FileClose(hTicksFile);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   SaveTempTicks();
  }
//+------------------------------------------------------------------+
